package robust.pm.cache;


import java.util.Hashtable;
import java.util.Enumeration;

import robust.pm.property.CSProperty;
import robust.pm.logger.CSLogger;

/**
 * ִѽð ĳø Ѵ. 
 * ýۿ  Cache Ÿ 
 * Thread ̿Ͽ ֱ Cache ClearѴ.
 * <pre>
 * ǻ 
 *   - Class ڵ Reload Ǵ ȯ濡 Class  VM    ü  Thread ڿ ȯ ʾ, 
 *     Class ޸𸮰 Clear ʴ   ִ.
 *   - ش  óϱ ؼ ĳÿ Ÿ  ° ӵɶ (100ȸ üũⰣ) Thread Ѵ. 
 * </pre>
 * 
 * @author ±
 *
 */
public class TimeCacheManager extends Thread {
	
	/** CacheManager ü  Singleton Instance */
	private	static	TimeCacheManager	cacheManager	=	null;
	
	/** ĳ TimeOut */
	private    long           m_lTimeOut      =   30 * 60 * 1000L;
	
	/** ĳ Clear Interval () : ⺻ 30 */
	private	   long			  m_lInterval		=	30 * 60 * 1000L;
	
	/** Cache ׷  Hashtable */
	private    Hashtable       ht              =   new Hashtable();
	
	/** Cache Clear Thread    */
	//private    boolean        m_bThreadRun    =   false;
	
	/**
	 * CacheManager 
	 * @return CacheManager ü
	 */
	private synchronized static void getInstance2() {
		
		if(cacheManager == null) {

			cacheManager 	= new TimeCacheManager();
			cacheManager.setDaemon(true);
			cacheManager.start();
		}
	}

	/** 
	 *  CacheManager Instance  Sington ü 䱸
	 * 
	 * @return CacheManager ü
	 */
	public static TimeCacheManager getInstance()  {

		if(cacheManager == null) {
			getInstance2();
		}
		
		return cacheManager;
	}

	/**
	 * CacheManager <BR>
	 * Property ʱȭ
	 */
	private TimeCacheManager() {

		super();
		init();
	}
	
	/**
	 * Property о鿩 ȯ漳  ʱȭ  
	 * <LI> α   TimeOut ֱ ()
	 */
	public void init() {
		try {
			m_lInterval	= Integer.parseInt(CSProperty.getInstance().getValue("CACHE_INTERVAL")) * 1000;
		} catch (Exception e) {
		}
		
		log("CacheManager", "init", "CACHE_INTERVAL : " + m_lInterval);
		
		try {
			this.m_lTimeOut	= Integer.parseInt(CSProperty.getInstance().getValue("CACHE_TIME_OUT")) * 1000;
		} catch (Exception e) {
		}
		
		log("CacheManager", "init", "CACHE_TIME_OUT : " + m_lTimeOut);
	}
	
	/**
	 * ĳ Manager ClearѴ.
	 * 
	 */
	public synchronized void clear() {
		cacheManager = null;
	}
	
	/**
	 * ĳ Ư ׷ Clear Ѵ.
	 */
	public synchronized void clearGroup(String sGroupName) {
		
		TimeCacheGroup  cacheGroup  = null;
		
		//  Hashtable   
		if(this.ht != null) {
			cacheGroup = (TimeCacheGroup) this.ht.get(sGroupName);
			if(cacheGroup != null)
				this.ht.remove(sGroupName);
		}
	}

	/**
	 * ĳ Manager ͸ Ѵ.
	 * @param cg CacheGroup 
	 */
	public static void monitor(TimeCacheGroup cg) {
		
		log("CacheManager", "monitor", "**************** " + cg.m_groupName + " Start **********************");
		
		Enumeration enu	=	cg.m_CacheData.elements();
		
		while(enu.hasMoreElements() ) {
			
			log(TimeCacheManager.class.getName(), "monitor", (CacheEntity)enu.nextElement());
			
		}
		
		log("CacheManager", "monitor", "**************** " + cg.m_groupName + " End **********************");
		
	}

	/**
	 *  αε   ü α׷ Ѵ. <BR>
	 *    ľ  ִ.
	 */
	public static void monitor() {

		Enumeration enu	=	TimeCacheManager.getInstance().ht.elements();
		
		log("CacheManager", "monitor", "**************** Monitor Start **********************");
		
		while(enu.hasMoreElements() ) {
			
			monitor((TimeCacheGroup) enu.nextElement());
			
		}
		
		log("CacheManager", "monitor", "**************** Monitor End **********************");
	}
	
	/**
	 * Thread ࿩θ true Ѵ.
	 * @return  
	 */
	/*
	private synchronized boolean setClearThreadRun() {
		
		if(m_bThreadRun) return false;
		m_bThreadRun = true;
		
		return true;
	}
	*/
	
	/**
	 * Thread 
	 *  Thread ΰ쿡  ʴ´. 
	 */
	/*
	private void clearThreadRun() {
		
		if(m_bThreadRun) {
			//log("CacheManager", "clearThreadRun", "[m_bThreadRun] is true");
			return;
		}
		
		if(setClearThreadRun()) {
			log("CacheManager", "clearThreadRun", "cacheManager.start()");
		}
	}
	*/

	/**
	 * Thread  α   ˻Ͽ,  ð  ڸ Ѵ.
	 * Ŵ ش Thread ϰ  ȿϵ Ѵ. 
	 */
	public void run() {
			
		int                         iCnt                = 0;
		int                         iNullThreadCnt      = 0;
		TimeCacheGroup                  cacheGroup          =   null;
		
		while(true) {
			
			iCnt = 0;
			
			if(this.ht != null) {
	
				Hashtable tmpHmFile = (Hashtable) this.ht.clone();
				
				Enumeration enu	=	tmpHmFile.elements();
				
				log("CacheManager", "run", "**************** TimeCheck Start **********************");
				
				if(enu != null) {
					
	    			while(enu.hasMoreElements()) {
	
	    				cacheGroup = (TimeCacheGroup) enu.nextElement();
	
	    				iCnt += cacheCheck(cacheGroup);
	    			}
				}
				
				log("CacheManager", "run", "**************** TimeCheck End ********************** ");
			}
			 
			if(iCnt == 0) {
				iNullThreadCnt ++;
			} else {
				iNullThreadCnt = 0;
			}
			
			// ĳÿ Ÿ °찡 ӵȰ, ش Cache 带 ڵ Ѵ. 
			if(iNullThreadCnt > 100) {
				clear();
				break;
			}

			{
				try {
					Thread.sleep(m_lInterval);
				} catch (Exception e) {
					log(e);
				}
			}
		}
	}
	
	/**
	 * ĳ   мϿ ȿð  ĳõŸ Ѵ.
	 * @param cacheGroup м ĳñ׷
	 */
	private int cacheCheck(TimeCacheGroup cacheGroup) {
		
		int	        sCnt        = 0;
		long       lCurTime    = System.currentTimeMillis(); 
		CacheEntity cacheEntity = null;
		
		if(cacheGroup == null || cacheGroup.m_CacheData == null) {
			log("CacheManager", "cacheCheck", "cacheGroup is null OR cacheGroup.m_CacheData is null");
			return 0;
		}
		
		lCurTime -= cacheGroup.m_lTimeOut;
	   
		log("CacheManager", "cacheCheck", "**************** Cache Check Start **********************");
		
		Hashtable tmpHmFile = (Hashtable) cacheGroup.m_CacheData.clone();
		Enumeration enu	=	tmpHmFile.elements();
		
		if(enu != null) {

			for(sCnt = 0; enu.hasMoreElements(); sCnt ++ ) {
				
				cacheEntity = (CacheEntity) enu.nextElement();

	    		if(isExpired(cacheEntity.m_lLastUpdatedTime, cacheGroup.m_lTimeOut)) {
	    			cacheGroup.m_CacheData.remove(cacheEntity.m_sKey);
    				log("CacheManager", "cacheCheck", "REMOVE : " + cacheEntity.m_sKey);
	    		}
			}
			
		}
		
		log("CacheManager", "cacheCheck", "**************** Cache Check END (" + sCnt + ") **********************");
		
		return sCnt;
	}
	
	private boolean isExpired(long lBaseTime, long lInterval) {
		
		if(lBaseTime + lInterval < System.currentTimeMillis())
			return true;
		else 
			return false;
		 
	}
	
	/**
	 * ĳ÷  űԵŸ Ѵ.
	 * ĳȿð   Ѵ.
	 * @param sGroupName ׷
	 * @param sCacheKey ĳkey
	 * @param o ĳõŸ
	 */
	public void setData(String sGroupName, String sCacheKey, Object o) {
		setData(sGroupName, this.m_lTimeOut, sCacheKey, o );
	}
	
	/**
	 * ĳ÷  űԵŸ Ѵ.
	 * @param sGroupName ׷
	 * @param lTimeOut ĳõŸ ȿð
	 * @param sCacheKey ĳkey
	 * @param o ĳõŸ
	 */
	public void setData(String sGroupName, long lTimeOut, String sCacheKey, Object o) {
		
		TimeCacheGroup  cacheGroup  = null;
		CacheEntity cacheEntity = null;
		
//		  Hashtable   
		if(this.ht == null) this.ht = new Hashtable();
		
		cacheGroup = (TimeCacheGroup) this.ht.get(sGroupName);
		
		if(cacheGroup == null) {
			//   ĳñ׷  
			cacheGroup = new TimeCacheGroup();
			cacheGroup.m_groupName = sGroupName;
			cacheGroup.m_lTimeOut = lTimeOut;
			this.ht.put(cacheGroup.m_groupName, cacheGroup);
			
		} 
		
		cacheEntity = (CacheEntity) cacheGroup.m_CacheData.get(sCacheKey);
		
		if(cacheEntity != null) {
			//   ĳõŸ 
			log("CacheManager", "setCache", "Cache " + sCacheKey + " Replace");
			cacheGroup.m_CacheData.remove(sCacheKey);
		} else {
			cacheEntity = new CacheEntity();
			cacheEntity.m_sKey = sCacheKey;
		}
		
		cacheEntity.m_lLastUpdatedTime = System.currentTimeMillis();
		cacheEntity.m_oData = o;
		
		cacheGroup.m_CacheData.put(sCacheKey, cacheEntity);
		
	}
	
	/**
	 * ĳõŸ ȸѴ. 
	 * @param sGroupName ׷
	 * @param sCacheKey ĳŰ
	 * @return ĳõŸ 
	 */
	public Object getData(String sGroupName, String sCacheKey) {
		
		CacheEntity cacheEntity = getCacheEntity(sGroupName, sCacheKey);
		
		if(cacheEntity == null) return null;
				
		return cacheEntity.m_oData;
	}
	
	/**
	 * ĳEntity ȸѴ. 
	 * @param sGroupName ׷
	 * @param sCacheKey ĳŰ
	 * @return ĳõŸ 
	 */
	public CacheEntity getCacheEntity(String sGroupName, String sCacheKey) {
		
		TimeCacheGroup  cacheGroup  = null;
		CacheEntity cacheEntity = null;
		
		//  Hashtable   
		if(this.ht == null) return null;
		
		cacheGroup = (TimeCacheGroup) this.ht.get(sGroupName);
		
		if(cacheGroup == null) {
			//   ĳñ׷  
			return null;
		} 
		
		if(cacheGroup.m_CacheData == null) {
			// ĳ Hashtable NULL϶ 
			return null;
		}
		
		cacheEntity = (CacheEntity) cacheGroup.m_CacheData.get(sCacheKey);
		
		if(cacheEntity == null || isExpired(cacheEntity.m_lLastUpdatedTime, cacheGroup.m_lTimeOut)) {
			// CacheEntity NULL϶ Ǵ TimeOut  Ÿ϶
			return null;
		}
		
		return cacheEntity;
	}
	
	/**
	 * α ޽  α׸  Ѵ.
	 * @param sClassName	αױ Class Name
	 * @param sMethodName 	αױ Method Name
	 * @param cacheEntity αױ Entity 
	 */
	public static void log(Throwable t) {
		
		//LogWriter.getInstance().log(PropertyManager.getInstance().getValue("TF", "SERVLET_LOG_DIR"), LogWriter.LEVEL.ERROR, t);
		
	}
	
	/**
	 * α ޽  α׸  Ѵ.
	 * @param sClassName	αױ Class Name
	 * @param sMethodName 	αױ Method Name
	 * @param cacheEntity αױ Entity 
	 */
	public static void log(String sClassName, String sMethodName, CacheEntity cacheEntity) {
		CSLogger.info(cacheEntity.m_oData.toString());
		//LogWriter.getInstance().log(PropertyManager.getInstance().getValue("TF", "SERVLET_LOG_DIR"), LogWriter.LEVEL.DEBUG, "CacheManager", "log", cacheEntity.m_oData.toString());
		
	}

	/**
	 * α ޽  α׸  Ѵ.
	 * @param sClassName	αױ Class Name
	 * @param sMethodName 	αױ Method Name
	 * @param sMsg αױϳ
	 */
	public static void log(String sClassName, String sMethodName, String sMsg) {
		CSLogger.info(sMsg);
		//LogWriter.getInstance().log(PropertyManager.getInstance().getValue("TF", "SERVLET_LOG_DIR"), LogWriter.LEVEL.DEBUG, "CacheManager", "log", sMsg);
		
	}

	/**
	 * α ޽  α׸  Ѵ.
	 * @param sClassName	αױ Class Name
	 * @param sMethodName 	αױ Method Name
	 * @param loginManagerEntity αױ Entity 
	 * @param sMsg	α׸޽
	 */
	public static void log(int mode, String sClassName, String sMethodName, String sMsg) {
		CSLogger.info(sMsg);
		//LogWriter.getInstance().log(PropertyManager.getInstance().getValue("TF", "SERVLET_LOG_DIR"), mode, "CacheManager", "log", sMsg);
	}
}





