package robust.pm.code;

import java.sql.SQLException;

import robust.pm.cache.TimeCacheManager;

import robust.pm.code.CodeDAO;
import robust.pm.code.CodeEntity;

/**
 *======================================================
 * @Ŭ : TCmnGenCdManager
 * @ۼ  : Administrator
 * @    : ڵ
 *======================================================
 * @̷ - , , 
 *
 *======================================================
 */ 
public class CodeManager {
	/**
	 * ڵ  ȸ DAO
	 */
	private static CodeDAO m_TCmnGenCdDAO;
	
	/** ڵ ĳ ׷ */
	private static final String CMN_GEN_CD_GRP = "CMN_GEN_CD_GRP";
	
	/** ڵ TIME OUT : 60 */	
	private static final int    TIME_OUT  = 60 * 60 * 1000;
	
	/**  ĳ νźƮ */
	private static TimeCacheManager tcCache = TimeCacheManager.getInstance();
	
	/**
	 *======================================================
	 * @޼ҵ : CodeManager - getCode
	 * @ۼ  : Administrator
	 * @return  : CodeEntity[]
	 * @param grpNm
	 * @    :  ڵ ׷  ȸѴ. 
	 *======================================================
	 * @̷ : , , 
	 *======================================================
	 */
	public static CodeEntity[] getCode(CodeEntity pEntity) throws SQLException{
		CodeEntity[] cacheEntity = null;
		String sCacheKey = pEntity.m_sGenGrpCd;
		
		if(tcCache != null){ 
			cacheEntity = (CodeEntity[])tcCache.getData(CMN_GEN_CD_GRP, sCacheKey);
		}
		
		if(cacheEntity == null) {
			if (m_TCmnGenCdDAO == null) {
				m_TCmnGenCdDAO = new CodeDAO();
			}
			cacheEntity = m_TCmnGenCdDAO.selectCode(pEntity);
			
			if(tcCache != null){ 
				tcCache.setData(CMN_GEN_CD_GRP, TIME_OUT, sCacheKey, cacheEntity);
			}
		}
		
		return cacheEntity;
	}
	
	/**
	 *======================================================
	 * @޼ҵ : CodeManager - listTotal
	 * @ۼ  : Administrator
	 * @return  : int
	 * @param pEntity
	 * @    : ڵ Ʈ  Ǽ 
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public static int listTotal(CodeEntity pEntity) throws SQLException{
		if (m_TCmnGenCdDAO == null) {
			m_TCmnGenCdDAO = new CodeDAO();
		}
		return m_TCmnGenCdDAO.listTotal(pEntity);
	}
	
	/**
	 *======================================================
	 * @޼ҵ : TCmnGenCdManager - list
	 * @ۼ  : Administrator
	 * @return  : TCmnGenCdEntity[]
	 * @param pEntity
	 * @    : ڵ ȸ Ʈ
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public static CodeEntity[] list(int iPage,int iPagePerCnt,CodeEntity pEntity) throws SQLException{
		if (m_TCmnGenCdDAO == null) {
			m_TCmnGenCdDAO = new CodeDAO();
		}
		return m_TCmnGenCdDAO.list(iPage,iPagePerCnt,pEntity);
	}
	
	/**
	 *======================================================
	 * @޼ҵ : CodeManager - getGrpCode
	 * @ۼ  : Administrator
	 * @return  : CodeEntity[]
	 * @param pEntity
	 * @    : ׷ ڵ尪 ȸѴ.
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public static CodeEntity[] getGrpCode(CodeEntity pEntity) throws SQLException{
		if (m_TCmnGenCdDAO == null) {
			m_TCmnGenCdDAO = new CodeDAO();
		}
		return m_TCmnGenCdDAO.getGrpCode(pEntity);
	}
	
	/**
	 *======================================================
	 * @޼ҵ : CodeManager - insert
	 * @ۼ  : Administrator
	 * @return  : int
	 * @param pEntity
	 * @    : ڵ尪 Ѵ.
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public static int insert(CodeEntity pEntity) throws SQLException{
		int rtnCk = 0;
		
		if (m_TCmnGenCdDAO == null) {
			m_TCmnGenCdDAO = new CodeDAO();
		}
		
		rtnCk = m_TCmnGenCdDAO.insert(pEntity);
		
		//ĳ ش.
		if(tcCache != null){ 
			tcCache.clearGroup(CMN_GEN_CD_GRP);
		}
		
		return rtnCk;
	}
	
	/**
	 *======================================================
	 * @޼ҵ : TCmnGenCdManager - insert
	 * @ۼ  : Administrator
	 * @return  : int
	 * @param pEntity
	 * @    : ڵ尪 Ѵ.
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public static int modify(CodeEntity pEntity) throws SQLException{
		int rtnCk = 0;
		
		if (m_TCmnGenCdDAO == null) {
			m_TCmnGenCdDAO = new CodeDAO();
		}
		
		rtnCk = m_TCmnGenCdDAO.modify(pEntity);
		
		//ĳ ش.
		if(tcCache != null){ 
			tcCache.clearGroup(CMN_GEN_CD_GRP);
		}
				
		return rtnCk;
	}
	
	/**
	 *======================================================
	 * @޼ҵ : CodeManager - select
	 * @ۼ  : Administrator
	 * @return  : TCmnGenCdEntity
	 * @param pEntity
	 * @    : ڵ ȸѴ.
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public static CodeEntity select(CodeEntity pEntity) throws SQLException{
		if (m_TCmnGenCdDAO == null) {
			m_TCmnGenCdDAO = new CodeDAO();
		}
		return m_TCmnGenCdDAO.select(pEntity);
	}
}
