package robust.pm.dao;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import robust.pm.entity.TimesheetEntity;


public class TimesheetDAO {
	//ͺ̽    
	private Connection conn = null;
	private PreparedStatement pstmt = null;


	//ͺ̽    ڿ 
	private String jdbc_driver = "com.mysql.jdbc.Driver";
	private String jdbc_url = "jdbc:mysql://localhost:3306/robust";

	void connect() {
		//JDBC ̹ ε
		try {
			Class.forName(jdbc_driver); //ε
			//ͺ̽  ̿ connection νϽ Ȯ
			conn = (Connection) DriverManager.getConnection(jdbc_url,
					"robust", "robust"); //
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	void disconnect() {
		if (pstmt != null) {
			try {
				pstmt.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		if (conn != null) {
			try {
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}

	public boolean insertDB(TimesheetEntity timesheet) {
		connect();
		//ϴ entity ּóѰ͵ Ƚ!
		String sql = "insert into ttimesheet(ts_content,ts_day,ts_month,ts_num,ts_title,ts_type,ts_year) values(?,?,?,?,?,?,?)";

		try {
			pstmt = conn.prepareStatement(sql);
			
			pstmt.setString(1, timesheet.getTs_content());
			pstmt.setInt(2, timesheet.getTs_day());
			pstmt.setInt(3, timesheet.getTs_month());
			pstmt.setInt(4, timesheet.getTs_num());
			pstmt.setString(5, timesheet.getTs_title());
			pstmt.setString(6, timesheet.getTs_type());
			pstmt.setInt(7, timesheet.getTs_year());
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			disconnect();
		}

		return true;
	}


	//̹ Ǿ ִ  ϴ 
	public boolean updateDB(TimesheetEntity timesheet) {
		connect();

		String sql = "update ttimesheet set ts_content=?,ts_day=?,ts_month=?,ts_num=?,ts_title=?,ts_type=?,ts_year=?";
	
		try {
			pstmt = conn.prepareStatement(sql);
			
			pstmt.setString(1, timesheet.getTs_content());
			pstmt.setInt(2, timesheet.getTs_day());
			pstmt.setInt(3, timesheet.getTs_month());
			pstmt.setInt(4, timesheet.getTs_num());
			pstmt.setString(5, timesheet.getTs_title());
			pstmt.setString(6, timesheet.getTs_type());
			pstmt.setInt(7, timesheet.getTs_year());
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			disconnect();
		}

		return true;
	}


	// Խù ϱ  ޼
	public boolean deleteDB(int ts_id) {
		connect();

		String sql = "delete from ttimesheet where ts_id=?";

		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, ts_id);
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			disconnect();
		}

		return true;
	}


	
	////߿ ڵ Ǵ ̺  Է½ߵ!!!><><><//////
	public TimesheetEntity get_UserDB(int ts_id) {
		connect();

		String sql = "select * from ttimesheet where ts_id=?";
		TimesheetEntity timesheet = new TimesheetEntity();

		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, ts_id);
			ResultSet rs = pstmt.executeQuery();			
			rs.next();
			timesheet.setTs_id(rs.getInt("ts_id"));
			timesheet.setTs_content(rs.getString("ts_content"));
			timesheet.setTs_day(rs.getInt("ts_day"));
			timesheet.setTs_month(rs.getInt("ts_month"));
			timesheet.setTs_num(rs.getInt("ts_num"));
			timesheet.setTs_title(rs.getString("ts_title"));
			timesheet.setTs_type(rs.getString("ts_type"));
			timesheet.setTs_year(rs.getInt("ts_num"));



			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}

		return timesheet;
	}

	//Խù  ֱ  ϴ ż(͸ Ѳ ´)
	public ArrayList<TimesheetEntity> get_UserDBList() {
		connect();
		ArrayList<TimesheetEntity> datas = new ArrayList<TimesheetEntity>();

		String sql = "select * from ttimesheet ";

		try {
			pstmt = conn.prepareStatement(sql);
			ResultSet rs = pstmt.executeQuery();

			while (rs.next()) {
				TimesheetEntity timesheet = new TimesheetEntity();

				timesheet.setTs_id(rs.getInt("ts_id"));
				timesheet.setTs_content(rs.getString("ts_content"));
				timesheet.setTs_day(rs.getInt("ts_day"));
				timesheet.setTs_month(rs.getInt("ts_month"));
				timesheet.setTs_num(rs.getInt("ts_num"));
				timesheet.setTs_title(rs.getString("ts_title"));
				timesheet.setTs_type(rs.getString("ts_type"));
				timesheet.setTs_year(rs.getInt("ts_num"));
				datas.add(timesheet);
			}
			rs.close();

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}

		return datas;
	}
}
