package robust.pm.http;

import java.util.HashMap;
import java.util.ArrayList;

import robust.pm.auth.AuthEntity;
import robust.pm.property.CSProperty;
import robust.pm.property.PropertyManagerWrapper;


/**
 * JSP  ڵȭ ó  ȯ漳  Ѵ.
 *
 */
public class WebConfig {
    
    /** ⺻ α н   */
    public  static final String DEFAULT_LOGIN_FAIL_ERROR_PAGE = CSProperty.getInstance().getValue("DEFAULT_LOGIN_FAIL_ERROR_PAGE");
    
   
    /** ⺻   */
    public  static final String DEFAULT_ERROR_PAGE = CSProperty.getInstance().getValue("DEFAULT_ERROR_PAGE");
    
    /** ⺻ ÷ Upload */
    public static final String	DEFAULT_UPLOAD_DIR = CSProperty.getInstance().getValue("FILE_UPLOAD_DIR");

    public  static final String REDIRECT_LEVEL_1 = "1";
    public  static final String REDIRECT_LEVEL_2 = "2";
    public  static final String REDIRECT_LEVEL_3 = "3";
    
    /** Connection  û */
    private     ArrayList       m_ReqConnList           =   null;
    
    /** Login üũ   */
    private     boolean        m_bIsCheckLogin         =   true;
    
    /** Login Fail ڵ Jump  */
    private     boolean        m_bIsLoginFailAutoJump  =   true;
    
    /** Login Fail ڵ Jump Page  */
    private     String          m_sLoginFailJumpPage    =   DEFAULT_LOGIN_FAIL_ERROR_PAGE;

    /** ÷ ε   */
    private		String			m_sUploadDir			= 	DEFAULT_UPLOAD_DIR;
    
    /** ÷ α ִ ũ : MByte  */
    private 	int				m_iMaxUploadSize		= 	10;		// ⺻ 10M
    
    /**   */
    private     StringBuffer    m_Error                 =   null;
    
    /** Ÿ   */
    private     String          m_sReserved1            =   null;
    /** Ÿ   */
    private     String          m_sReserved2            =   null;

    /** ߻ Jump URL */
    private     String          m_sErrorJumpPage        =   DEFAULT_ERROR_PAGE;
    
    /**    Entity */
    private     AuthEntity      m_AuthEntity            =   null;
    
    /**    */
    private 	String			m_sLangSet				=   CSProperty.getInstance().getValue("LANG_SET");	// Default
    
    /**  ε  ȭϸ   ڵ   */
    private 	boolean			m_bAttachFileAutoRename = 	true;

    
    /**
     * α üũ  
     *
     * @param iIsCheckLogin α 
     */
    public void setIsCheckLogin(boolean bIsCheckLogin) {
        this.m_bIsCheckLogin = bIsCheckLogin;
    }
    /**
     * α н ڵ Jump  
     *
     * @param iIsLoginFailAutoJumpα н ڵ Jump 
     */
    public void setIsLoginFailAutoJump(boolean bIsLoginFailAutoJump) {
        this.m_bIsLoginFailAutoJump = bIsLoginFailAutoJump;
    }
    /**
     * α н Jump Page 
     *
     * @param sLoginFailJumpPage α н Jump Page
     */
    public void setLoginFailJumpPage(String sLoginFailJumpPage) {
        this.m_sLoginFailJumpPage = sLoginFailJumpPage;
    }

    /**
     *  ߻ Jump Page 
     *
     * @param sErrorJumpPage ߻ Jump Page
     */
    public void setErrorJumpPage(String sErrorJumpPage) {
        this.m_sErrorJumpPage = sErrorJumpPage;
    }

    /**
     *  
     *
     * @param sError 
     */
    public void setIsCheckMenuAuth(String sError) {
        if(this.m_Error == null)    this.m_Error = new StringBuffer(sError);
        else                        this.m_Error.append(sError);
    }

    /**
     *  Entity 
     *
     * @param iIsCheckLogin α 
     */
    public void setAuthEntity(AuthEntity authEntity) {
        this.m_AuthEntity = authEntity;
    }

    /**
     *  
     * @param sErrorMsg
     */
    public void setError(String sErrorMsg) {

        if(this.m_Error == null)    this.m_Error = new StringBuffer();

        this.m_Error.append(sErrorMsg);

    }
    /**
     * ÷ ε ⺻ 丮 
     * @param sUploadDir
     */
    public void setUploadDir(String sUploadDir) {
    	this.m_sUploadDir = sUploadDir;
    }
    
    /**
     * ÷ ε ִũ 
     * @param iMaxUploadSize ε ִũ (MBytes)
     */
    public void setMaxUploadDize(int iMaxUploadSize) {
    	this.m_iMaxUploadSize = iMaxUploadSize;
    }
    /**
     *  #1 
     *
     * @param sReserved1  #1
     */
    public void setReserved1(String sReserved1) {
        this.m_sReserved1 = sReserved1;
    }
    /**
     *  #2 
     *
     * @param sReserved2  #2
     */
    public void setReserved2(String sReserved2) {
        this.m_sReserved2 = sReserved2;
    }

    
    /**
     *    
     *
     * @param sReserved3 
     */
    public void setLangSet(String sLangSet) {
        this.m_sLangSet = sLangSet;
    }
    
    /**
     *  ÷ ε   ϸ ϸ ϸ  θ 
     *  @param bAttachFileAutoRename ÷ ڵ ̸
     */
    public void setAttachFileAutoRename(boolean bAttachFileAutoRename) {
    	this.m_bAttachFileAutoRename = bAttachFileAutoRename;
    }

    /**
     * DB  Connection û ȸ
     *
     * @return Connection  û
     */
    public ArrayList getReqConn() {
        return this.m_ReqConnList;
    }
    /**
     * Login üũ ȸ
     *
     * @return Login üũ
     */
    public boolean getIsCheckLogin() {
        return this.m_bIsCheckLogin;
    }
    /**
     * Login н ڵ Jump ȸ
     *
     * @return Login н ڵ Jump
     */
    public boolean getIsLoginFailAutoJump() {
        return this.m_bIsLoginFailAutoJump;
    }
    /**
     * Login н Jump Page ȸ
     *
     * @return Login н Jump Page
     */
    public String getLoginFailJumpPage() {
        return this.m_sLoginFailJumpPage;
    }
    /**
     *  ߻ Jump Page ȸ
     *
     * @return  ߻ Jump Page
     */
    public String getErrorJumpPage() {
        return this.m_sErrorJumpPage;
    }

    /**
     *  ޽ ȸ
     *
     * @return  ޽
     */
    public String getError() {

        if(this.m_Error == null)    return "";

        return this.m_Error.toString();
    }
    
    /**
     * ε 丮 ȸ
     * @return ε 丮 
     */
    public String getUploadDir() {
    	return this.m_sUploadDir;
    }
    
    /**
     * ε ִũ ȸ (MBytes )
     * @return ε ִũ
     */
    public int getMaxUploadSize() {
    	return this.m_iMaxUploadSize;
    }
    /**
     * α  ȸ
     *
     * @return α 
     */
    public AuthEntity getAuthEntity() {
        return this.m_AuthEntity;
    }

    /** 
     *  1
     */
    public String   getReserved1() {
        return this.m_sReserved1;
    }

    /** 
     *  2
     */
    public String   getReserved2() {
        return this.m_sReserved2;
    }

    /**  ȸ */
    public String getLangSet() {
        return this.m_sLangSet;
    }
    
    /** ÷ ε ϸ ڵ   */
    public boolean getAttachFileAutoRename() {
    	return this.m_bAttachFileAutoRename;
    }
}
