
/*******************************************************************
 * 1.class              : LogWriterThread.java
 * 2.class            : Thread ̿ αױ
 *******************************************************************/

package robust.pm.logger;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import robust.pm.util.DateFormat4Performance;

/**
 * α׸ ϴ Thread Ѵ.
 * 1. α File   CashingѴ.
 * 2. α׹۸ ̿Ͽ ޸ Buffer  ϰ ̸ Ѵ.
 */
public class LogWriterThread implements Runnable {

    /** α׸ ϰ   */
    private     Vector      logQueue        = new Vector();
    /** α Thread   */
    private     boolean     shouldRun       = false;

    /** 
     * α   Fileü : ϸ Key . 
     * α   .
     */
    private     HashMap     hmFile          = new HashMap();
    
    /**
     * αױ  Open File ü Cache 
     */
    private class FileWriterInfo {
        /** File */
        public String      sFileName   = null;
        /** File  */
        public File        file        = null;
        /** FileWriter  */
        public FileWriter  fileWriter  = null;
        /** PrintWriter  */
        public PrintWriter printWriter = null;
        /**  TimeStamp */
        public long createTimeStamp    = 0L;
        /**  TimeStamp */
        public long accessTimeStamp    = 0L;
        /**   LIMIT  : 1ð */
        public final static long LIMIT_TIME_STAMP = 60 * 60 * 1000;
        //public final static long LIMIT_TIME_STAMP = 60 * 1000;
    }
    /**
     * αױ FileWriter Cache  Clear ð
     */
    private long    fileWriterClearTimeStamp = System.currentTimeMillis();
    
    /**
     * αױ FileWriter Cache Clear ֱ : 1ð
     */
    private final long CLEAR_INTERVAL = 60 * 60 * 1000;
    //private final long CLEAR_INTERVAL = 60 * 1000;

    /**
     * Class 
     */
    public LogWriterThread() {
    }
    
    /**
     * <code>runIt</code> LogEntity  ϰ runIt() 
     * @param    sFileName         α׸ ϴ 丮
     * @param    sClassName        α׸  Ŭ ̸
     * @param    sMethodName       α׸  ޼ҵ ̸
     * @param    sMode             αMode
     * @param    sErrorTrace       α׸  Thread 
     * @param    sMsg              α׸  ϴ ޽
     */
    public void runIt(String sFileName, String sClassName, String sMethodName, String sMode, String sErrorTrace, String sMsg) {
    
        LogEntity logEntity             = LogEntityObjectPool.getInstance().pop();
        logEntity.clear();
        
        logEntity.m_sFileName           = sFileName;
        logEntity.m_sClassName          = sClassName;
        logEntity.m_sMethodName         = sMethodName;
        logEntity.m_sMode               = sMode;
        logEntity.m_sErrTrace           = sErrorTrace;
        logEntity.m_sMsg                = sMsg;
        logQueue.add(logEntity);
//System.out.println(logEntity.toString());
//System.out.println("shouldRun : " + shouldRun);
        if(shouldRun == false)         runIt();
    }

    /**
    * <code>runIt</code> LogEntity  ϰ runIt() 
    * @param     sFileName               α׸ ϴ 丮
    * @param     e                  Exception ü
    */
    public void runIt(String sFileName, String sMode, String sErrorTrace, Throwable e) {
    
        LogEntity logEntity             = LogEntityObjectPool.getInstance().pop();
        logEntity.clear();
        
        logEntity.m_sFileName           = sFileName;
        logEntity.m_sMode               = sMode;
        logEntity.m_sErrTrace           = sErrorTrace;
        logEntity.m_e                   = e;
        logQueue.add(logEntity);
//System.out.println(logEntity.toString());
//System.out.println("shouldRun : " + shouldRun);
        if(shouldRun == false)         runIt();
    }
    
    /**
    * <code>run</code> Thread 
    */
    public void run() {
    
        long       curTimeStamp     = 0L;
        int        size             = 0;
        int        sleepCnt         = 0;
        
        int		   cnt              = 0;
    
        while(true) {

        	// System.out.println("logQueue Call - " + cnt++);
        	
            size    = logQueue.size();
            
            if(shouldRun && size > 0) {

                sleepCnt = 0;

                for(int i=0; i < size; i++) write();
                
                curTimeStamp = System.currentTimeMillis();
                if(curTimeStamp > fileWriterClearTimeStamp + CLEAR_INTERVAL) {
                    clearPrintWriter();
                }
            } else {
                
            	// System.out.println("logQueue size is null... : " + Thread.currentThread().getName());
            	
                shouldRun = false;
                try {
                    synchronized(this) {
                        this.wait();
                    }
                } catch (InterruptedException ie) {
                    ie.printStackTrace(System.err);
                    sleepCnt ++;
                } catch (IllegalMonitorStateException imse) {
                    imse.printStackTrace(System.err);
                    sleepCnt ++;
                } finally {
                }
            }
            
            // LogWriter ѷ ° Ѵ.
            if(sleepCnt > 10000) {
                break;
            }
        }
    }
    
    /**
    * <code>runIt</code> notifyAll() 
    */
    public void runIt() {
        
        shouldRun = true;
        
        try {
            synchronized(this) {
                notifyAll();
            }
        } catch (IllegalMonitorStateException imse) {
            imse.printStackTrace(System.err);
        }
    }
    
    /**
     * Cashing Ǿִ    ִ FileWriterInfoü ȸѴ.
     *   ȭΰ  Ͽ FileWriterInfoü ȯѴ. 
     * @param sFileName  Log File (FULL PATH)
     * @return FileWriterInfo ü
     */
    public FileWriterInfo getPrintWriter(String sFileName) {
        
        FileWriterInfo   fileWriterInfo = null;
        
        fileWriterInfo = (FileWriterInfo) hmFile.get(sFileName);
        //   
        if(fileWriterInfo == null) {
            
            fileWriterInfo = new FileWriterInfo();
            
            try {
                fileWriterInfo.sFileName        = sFileName;
                fileWriterInfo.file             = new File(sFileName);
                fileWriterInfo.fileWriter       = new FileWriter(fileWriterInfo.file.getAbsolutePath(), true);     // APPEND MODE
                fileWriterInfo.printWriter      = new PrintWriter(new BufferedWriter(fileWriterInfo.fileWriter), false);    // AUTO Flush True
                fileWriterInfo.createTimeStamp  = System.currentTimeMillis();
                fileWriterInfo.accessTimeStamp	= fileWriterInfo.createTimeStamp;
                
                hmFile.put(sFileName, fileWriterInfo);
                
                System.out.println("Log File Open : [" + sFileName + "]");
                
            } catch (IOException ioe) {
                ioe.printStackTrace(System.err);
            }
        } else {
        	fileWriterInfo.accessTimeStamp = System.currentTimeMillis();
        }
        
        return fileWriterInfo;
    }
    
    /**
     * Open  ð  PrintWriterCash ü ClearѴ
     */
    public void clearPrintWriter() {
        
        HashMap tmpHmFile = (HashMap) hmFile.clone();
        Collection coll = tmpHmFile.values();
        Iterator iterator = coll.iterator();
        
        if(iterator == null)    return;
        
        FileWriterInfo   fileWriterInfo = null;
        long             curTimeStamp   = System.currentTimeMillis();
        
        while(iterator.hasNext()) {
            
            fileWriterInfo = (FileWriterInfo) iterator.next();
            
            // ð
            if(curTimeStamp > fileWriterInfo.accessTimeStamp + FileWriterInfo.LIMIT_TIME_STAMP) {
            	
            	//System.out.println("curTimeStamp : " + fileWriterInfo.accessTimeStamp);
                
                fileWriterInfo = (FileWriterInfo) hmFile.remove(fileWriterInfo.sFileName);

                fileWriterInfo.printWriter.flush();
                fileWriterInfo.printWriter.close();
                
                System.out.println("Log File Close : [" + fileWriterInfo.sFileName + "] "+ Thread.currentThread().getName());
            }
        }
        
        fileWriterClearTimeStamp = System.currentTimeMillis();
    }
    
    /**
    * <code>write</code> α 
    */
    public void write() {
        
        LogEntity logEntity    = (LogEntity) logQueue.remove(0);

        if(logEntity.m_e == null) {
            write(logEntity);
        } else {
            writeThrowable(logEntity);
        }
        
        LogEntityObjectPool.getInstance().push(logEntity);
        
    }
    
    /**
    * <code>write</code> α 
    * @param sFileName      α  丮
    * @param e              Throwable ü
    */
    private void writeThrowable(LogEntity logEntity) {
    
       FileWriterInfo   fileWriterInfo  = null;
       PrintWriter      writer          = null;
       
        fileWriterInfo = getPrintWriter(logEntity.m_sFileName);
        writer = fileWriterInfo.printWriter;
        writer.print(
            (new StringBuffer().append("[").append(logEntity.m_sMode).append("] ")
                .append("<").append(getCurrentTime()).append("> ")
                .append("<").append(logEntity.m_sErrTrace).append(">\n")
            )
        );

        writer.println(logEntity.m_e.toString());
        logEntity.m_e.printStackTrace(writer);
        writer.println();
        writer.flush();
    } 
    
    /**
     * <code>write</code> α 
     * @param     sFileName              α  丮
     * @ param    sClassName        α׸  Ŭ ̸
     * @ param    sMethodName       α׸  ޼ҵ ̸
     * @ param    sMode             α Mode
     * @ param    sMsg              α׸  ϴ ޽
     */
    private void write(LogEntity logEntity) {

       FileWriterInfo   fileWriterInfo  = null;
       PrintWriter      writer          = null;
       
        fileWriterInfo = getPrintWriter(logEntity.m_sFileName);
        writer = fileWriterInfo.printWriter;

        writer.print(
            (new StringBuffer().append("[").append(logEntity.m_sMode).append("] ")
                .append("<").append(getCurrentTime()).append("> ")
                .append("<").append(logEntity.m_sErrTrace).append("> ")
                .append("<").append(logEntity.m_sClassName).append(".").append(logEntity.m_sMethodName).append(">\n")
            )
        );
        
        writer.println(logEntity.m_sMsg);
        writer.println();
        writer.flush();
    } 
    
    /**
     * <code>getCurrentTime</code>ڷ ־ Ͽ ´ ð Ʈ Ÿ ȯѴ.
     * @ return  ȣ  ð(YYYY/MM/DD HH24:MI.SS)
     */
    private static String getCurrentTime() {
        return DateFormat4Performance.getCurrentTimestampStringFormat();
    }
}
