package robust.pm.notice.service;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import robust.pm.dbmanager.*;

public class qIdGenerator {

	private static qIdGenerator instance = new qIdGenerator();
	public static qIdGenerator getInstance() {
		return instance;
	}

	private qIdGenerator() {
	}

	public int generateNextId(String sequenceName)
			throws qIdGenerationFailedException {
		Connection conn = null;
		PreparedStatement pstmtSelect = null;
		ResultSet rs = null;
		PreparedStatement pstmtUpdate = null;
		try {
			conn = DBCPConn.getConnection("pool");
			conn.setAutoCommit(false);
			pstmtSelect = conn.prepareStatement(
					"select next_value from qid_sequence " +
					"where sequence_name = ? for update");
			pstmtSelect.setString(1, sequenceName);
			rs = pstmtSelect.executeQuery();
			rs.next();
			int id = rs.getInt(1);
			id++;

			pstmtUpdate = conn.prepareStatement(
					"update qid_sequence set next_value = ? " +
					"where sequence_name = ?");
			pstmtUpdate.setInt(1, id);
			pstmtUpdate.setString(2, sequenceName);
			pstmtUpdate.executeUpdate();

			conn.commit();

			return id;
		} catch (SQLException ex) {
			JdbcUtil.rollback(conn);
			throw new qIdGenerationFailedException(ex);
		} finally {
			if (conn != null) {
				try {
					conn.setAutoCommit(true);
				} catch (SQLException e) {
				}
				JdbcUtil.close(conn);
			}
		}
	}

}
