package robust.pm.notice.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.text.DecimalFormat;
import java.util.Date;

import robust.pm.notice.dao.*;
import robust.pm.notice.model.*;
import robust.pm.dbmanager.*;

public class qWriteArticleService {
	private static qWriteArticleService instance = new qWriteArticleService();
	public static qWriteArticleService getInstance() {
		return instance;
	}

	private qWriteArticleService() {
	}

	public qArticle write(qWritingRequest writingRequest)
			throws qIdGenerationFailedException {

		int groupId = qIdGenerator.getInstance().generateNextId("qarticle");

		qArticle article = writingRequest.toArticle();

		article.setGroupId(groupId);
		article.setPostingDate(new Date());
		DecimalFormat decimalFormat = new DecimalFormat("0000000000");
		article.setSequenceNumber(decimalFormat.format(groupId) + "999999");

		Connection conn = null;
		try {
			conn = DBCPConn.getConnection("pool");
			conn.setAutoCommit(false);

			int qarticleId = qArticleDao.getInstance().insert(conn, article);
			if (qarticleId == -1) {
				JdbcUtil.rollback(conn);
				throw new RuntimeException("DB  ȵ: " + qarticleId);
			}
			conn.commit();

			article.setId(qarticleId);
			return article;
		} catch (SQLException e) {
			JdbcUtil.rollback(conn);
			throw new RuntimeException("DB : " + e.getMessage(), e);
		} finally {
			if (conn != null) {
				try {
					conn.setAutoCommit(true);
				} catch (SQLException e) {
				}
			}
			JdbcUtil.close(conn);
		}
	}
}
