package robust.pm.property;


import java.io.*;
import java.util.*;


public class CSProperty {
	
	/** JAVA CLASS PATH  */
	private static final String JAVA_CLASS_PATH = "java.class.path";
	
	/** USER_HOME  */
	private static final String USER_HOME = "user.home";
	
	/** ⺻ Ƽ  */
	private static final String BASE_PROPERTY_FILE = "prop";
	
	/** Ƽ  Ȯ */
	private static final String BASE_PROPERTY_FILE_EXT = ".properties";

	private Hashtable	m_prop;
	/**
	* properties ȭ о 帮 κ 
	*/

	/** ̱水ü  */
	private static CSProperty	instance;

	/**
	 * ̱  LdapManager ü Ѵ.
	 * @ return		LdapManager
	 */
	static public CSProperty getInstance() {
		if (instance == null)
			instance = new CSProperty();
		return instance;
	}

	/**
	 * ü .
	 */
	private CSProperty() {
		initialize();
	}

	/**
	 * ý ClassPath  prop.properties  ã´.
	 * 
	 */
	public void initialize() {

		ResourceBundle resourceBundle = null;
		
		try {
			resourceBundle = ReloadablePropertyResourceBundle.getResourceBundle(BASE_PROPERTY_FILE);
		} catch (Exception e) {
			e.printStackTrace(System.err);
		}
		
		if(resourceBundle == null) {
		} else {
			
			this.m_prop = new Hashtable();
			
			Enumeration propKeyList = resourceBundle.getKeys();  
			
			while(propKeyList.hasMoreElements()) {
				String sKeyName = (String)propKeyList.nextElement();
				this.m_prop.put(sKeyName, resourceBundle.getString(sKeyName));
			}
		}
	}
	

	/**
	*<code>getValue</code>  ش Key   
	* @param 	sKey						ش Property Key
	* @param		sDefValue					⺻
	* @return		(String)prop.get(sPropKey)	ش Key  
	*/
	public String getValue(String sKey, String sDefValue) {
		try {
			return (String)m_prop.get(sKey);
		}
		catch (NullPointerException npe) {
			System.out.println("Error : Key شϴ Value ã  ϴ." + npe);
			npe.printStackTrace(System.out);
			return sDefValue;
		}
	}

	public String getValue(String sKey) {
		try {
			return (String)m_prop.get(sKey);
		}
		catch (NullPointerException npe) {
			System.out.println("Error : Key شϴ Value ã  ϴ." + npe);
			npe.printStackTrace(System.out);
			return "";
		}
	}

	/**
	*<code>getIntValue</code> ش Key   
	* @param 	sKey										ش Property Key
	* @param		sPropKey									Propterty Main شϴ Key
	* @return		getIntValue(sKey, sPropKey, Integer.MIN_VALUE)	ش Key  Integer
	*/
	public int getIntValue(String sKey, int iDefValue) {
		String	sValue	= getValue(sKey);

		try {
			return Integer.parseInt(sValue);
		}
		catch (NullPointerException npe) {
			npe.printStackTrace(System.out);
			return iDefValue;
		}
		catch (NumberFormatException nfe) {
			nfe.printStackTrace(System.out);
			return iDefValue;
		}
	}
	
	/**
	 * Property Manager ׽Ʈ
	 */
	public static void main(String[] argv) {
		CSProperty property = CSProperty.getInstance();
	}
}
