package robust.pm.property;

/**
  * 1. class  			: PropetyManager.java
  * 2. class 		: Propeties ȭ о鿩 Schedule ....
  * 3.  ̺			:
  * 4.  class 		:
  * 5.  JSP 			:
  * 6.  ۼ/ۼ 	:
  * 7. ֱ / 	:
  * 8.   			:
  */

import java.io.*;
import java.util.*;


public class PropertyManager {
	
	/** JAVA CLASS PATH  */
	private static final String JAVA_CLASS_PATH = "java.class.path";
	
	/** USER_HOME  */
	private static final String USER_HOME = "user.home";
	
	/** TF Property HOME */
	private static final String TF_PROPERTY_HOME = "java.tf.property.home";
	
	/** ⺻ Ƽ  */
	private static final String BASE_PROPERTY_FILE = "prop";
	
	/** Ƽ  Ȯ */
	private static final String BASE_PROPERTY_FILE_EXT = ".properties";

	private Hashtable	m_propList;
	private Hashtable	m_prop;
	private String		m_sPropFilePath;
	/**
	* properties ȭ о 帮 κ 
	*/

	/** ̱水ü  */
	private static PropertyManager	instance;

	/**
	 * ̱  LdapManager ü Ѵ.
	 * @ return		LdapManager
	 */
	static public PropertyManager getInstance() {
		if (instance == null)
			instance = new PropertyManager();
		return instance;
	}

	/**
	 * ü .
	 */
	private PropertyManager() {
		initialize();
	}
	
	/**
	*    prop.properties  ã´. 
	* 
	* 1. java.tf.property.home   丮 prop.properties ȭ ã´.
	* 2. user.home   丮 prop.properties ȭ ã´.
	* 3. classpath   丮 prop.properties ȭ ã´.
	*/
	public boolean getPropertyFileCustom() {
		
		//String	sPropFileName	= null;
		String[] sPropertyHome = null;
		
		String  sPropFileName = null;
		 
		String	sFileSeperator	= File.separator;
		String  sPathSeperator  = File.pathSeparator;
		
		//  ü CLASS_PATH prop.properties ȸѴ.
		String  sClassPath  = System.getProperty(JAVA_CLASS_PATH);
		if(sClassPath != null) {
	        StringTokenizer    sb = new StringTokenizer(sClassPath, sPathSeperator);

	        sPropertyHome  = new String[sb.countTokens() + 2];
	        
	        // 0 1  user.home java.tf.property.home Ѵ. 
	        int i = 2;
	        while(sb.hasMoreTokens())
	        {
	        	sPropertyHome[i++] = sb.nextToken();
	        }
		} else {
			sPropertyHome  = new String[2];
		}

		// -Djava.tf.mig.property.home=/XXXX/XXXX/XXXX   Ȩ ؾ Ѵ.
		// 
		String	sUserHome	= System.getProperty(USER_HOME);
		String	sProperty	= System.getProperty(TF_PROPERTY_HOME);
		
		if(sProperty != null)
			sPropertyHome[0] = sProperty;
		
		if(sUserHome != null)
			sPropertyHome[1] = sUserHome + sFileSeperator + "property";
		
		for(int i = 0; i < sPropertyHome.length; i++) {
			if(sPropertyHome[i] != null)
				m_propList = readFile(sPropertyHome[i] + sFileSeperator + BASE_PROPERTY_FILE + BASE_PROPERTY_FILE_EXT);
			
			if(m_propList != null) {
				this.m_sPropFilePath = sPropertyHome[i];
				System.out.println(" Ƽ read success : [" + sPropertyHome[i] + sFileSeperator + BASE_PROPERTY_FILE + BASE_PROPERTY_FILE_EXT + "]");
				break;
			} 
		} 
		
		if(m_propList != null) {
			this.m_prop = new Hashtable();
			return true;
		} else 
			return false;
	}
	
	/**
	 * ý ClassPath  prop.properties  ã´.
	 * 
	 */
	private boolean getPropertyFile() {

		ResourceBundle resourceBundle = null;
		
		try {
			resourceBundle = ReloadablePropertyResourceBundle.getResourceBundle(BASE_PROPERTY_FILE);
		} catch (Exception e) {
			e.printStackTrace(System.err);
		}
		
		if(resourceBundle == null) {
			return false;
		} else {
			
			this.m_propList = new Hashtable();
			this.m_prop = new Hashtable();
			
			Enumeration propKeyList = resourceBundle.getKeys();  
			
			while(propKeyList.hasMoreElements()) {
				String sKeyName = (String)propKeyList.nextElement();
				this.m_propList.put(sKeyName, resourceBundle.getString(sKeyName));
			}
						
			return true;
		}
		
	}
	
	/**
	 *<code>initialize</code> PropertyManager ʱȭ
	 * 
     * 1. ClassPath prop.properties  ã´. 
     * 
	 */
	public void initialize() {
	
		if(getPropertyFile() || getPropertyFileCustom()) {
			try {				
				for (Enumeration enumeration = this.m_propList.keys(); enumeration.hasMoreElements(); ) {
					String sPropFileName = (String)enumeration.nextElement();
		       		initialize(sPropFileName);
	       		}
			}
			catch (NullPointerException npe) {
				npe.printStackTrace(System.err);
			}
		} else {
			System.err.println("[FATAL ERR] : \"" + BASE_PROPERTY_FILE + BASE_PROPERTY_FILE_EXT + "\"  ϴ.");
			System.err.println("[FATAL ERR] : CLASS_PATH ο \"" + BASE_PROPERTY_FILE + BASE_PROPERTY_FILE_EXT + "\"  ʿմϴ. ");
			System.err.println("[FATAL ERR] : ý   ʽϴ.");
		}
	}
	
	/**
	*<code>initialize</code> PropertyManager 2 ʱȭ 
	*/
	private synchronized void initialize(String sKey) {
		String	sPropFileName	= null;
		
		sPropFileName = (String)m_propList.get(sKey);
		
		//System.out.println("Property Loading : [" + sKey + "] [" + sPropFileName + "]");
		
		m_prop.put(sKey, readFile(sPropFileName));
	}
	
	/**
	*<code>getValue</code> ش Key   
	* @param 	sKey			ش Property Key
	* @param		sPropKey		Propterty Main شϴ Key
	* @return		getValue(sKey, sPropKey, null)
	*/
	public String getValue(String sKey, String sPropKey) {
		return getValue(sKey, sPropKey, null);
	}
	
	/**
	*<code>getValue</code>  ش Key   
	* @param 	sKey						ش Property Key
	* @param		sPropKey					Propterty Main شϴ Key
	* @param		sDefValue					⺻
	* @return		(String)prop.get(sPropKey)	ش Key  
	*/
	public String getValue(String sKey, String sPropKey, String sDefValue) {
		try {
			Hashtable	prop = (Hashtable)m_prop.get(sKey);
			
			return (String)prop.get(sPropKey);
		}
		catch (NullPointerException npe) {
			//System.out.println("Error : Key شϴ Value ã  ϴ." + e);
			//npe.printStackTrace(System.out);
			return sDefValue;
		}
	}
	
	/**
	*<code>getIntValue</code> ش Key   
	* @param 	sKey										ش Property Key
	* @param		sPropKey									Propterty Main شϴ Key
	* @return		getIntValue(sKey, sPropKey, Integer.MIN_VALUE)	ش Key  Integer
	*/
	public int getIntValue(String sKey, String sPropKey) {
		return getIntValue(sKey, sPropKey, Integer.MIN_VALUE);
	}
	
	/**
	*<code>getIntValue</code>  ش Key   
	* @param 	sKey						ش Property Key
	* @param		sPropKey					Propterty Main شϴ Key
	* @param		iDefValue					⺻
	* @return		Integer.parseInt(sValue)		ش Key  Integer
	*/
	public int getIntValue(String sKey, String sPropKey, int iDefValue) {
		String	sValue	= getValue(sKey, sPropKey);

		try {
			return Integer.parseInt(sValue);
		}
		catch (NullPointerException npe) {
//			npe.printStackTrace(System.out);
			return iDefValue;
		}
		catch (NumberFormatException nfe) {
//			nfe.printStackTrace(System.out);
			return iDefValue;
		}
	}
	
	/**
	*<code>getBoolValue</code> ش Key   
	* @param 	sKey								ش Property Key
	* @param		sPropKey							Propterty Main شϴ Key
	* @return		getBoolValue(sKey, sPropKey, false)	ش Key  Boolean
	*/
	public boolean getBooleanValue(String sKey, String sPropKey) {
		return getBooleanValue(sKey, sPropKey, false);
	}
	
	/**
	*<code>getBoolValue</code>  ش Key   
	* @param 	sKey								ش Property Key
	* @param		sPropKey							Propterty Main شϴ Key
	* @param		bDefValue							⺻
	* @return		(new Boolean(sValue)).booleanValue()	ش Key  Boolean
	*/
	public boolean getBooleanValue(String sKey, String sPropKey, boolean bDefValue) {
		String	sValue	= getValue(sKey, sPropKey);
		
		try {
			return (new Boolean(sValue)).booleanValue();
		}
		catch (NullPointerException npe) {
			npe.printStackTrace(System.out);
			return bDefValue;
		}
		catch (NumberFormatException nfe) {
			nfe.printStackTrace(System.out);
			return bDefValue;
		}
	}
	
	/**
	 * Ƽ (prop.properties) ϴ  ȸ
	 * @return θ
	 */
	public String getPropFilePath () {
		return this.m_sPropFilePath;
	}
	
	/**
	*  Properties File   о 鿩 HashTable ȯѴ.
	* @param sFile
	* @ return m_prop
	*/
	private Hashtable readFile(String sFileName) {
		
		Properties		prop	= null;
		File			file	= null;
		FileInputStream	fis	= null;
		
		try {
			file	= new File(sFileName);
			fis	= new FileInputStream(file);
			
			prop = new Properties();
			
			prop.load(new BufferedInputStream(fis));
			
			fis.close(); fis = null;
		} 
		catch (FileNotFoundException fnfe) {
		 	System.out.println("File Open [" + sFileName + "] : Not Exist");
		 	//fnfe.printStackTrace(System.out);
		}
		catch (IOException ioe) {
			ioe.printStackTrace(System.out);
			if (fis != null) try { fis.close(); fis = null; } catch (IOException e) {}
		}finally{
			if (fis != null) try { fis.close(); fis = null; } catch (IOException e) {}
		}
		
		return prop;
	}
	
	/**
	 * Property Manager ׽Ʈ
	 */
	public static void main(String[] argv) {
		PropertyManager property = PropertyManager.getInstance();
	}
}
