package robust.pm.user;

import java.sql.DriverManager;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import robust.pm.dbmanager.DBCPConn;
import robust.pm.user.UserEntity;
import robust.pm.util.StringUtil;

import robust.pm.logger.CSLogger;



/**
 *======================================================
 * @Ŭ : UserDAO
 * @    :   DAO
 *======================================================
 * @̷ - , , 
 *
 *======================================================
 */ 
public class UserDAO {
		
	/**
	 *    ȸ
	 * @param conn
	 * @param pEntity
	 * @return
	 * @throws SQLException
	 */
	public UserEntity select(UserEntity pEntity) throws SQLException {
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;

		UserEntity rtnEntity = new UserEntity();
		int index = 1;

		/** TUSER ̺  ȸѴ. **/
		String qry = 		
						"	SELECT 									\n"
					+	"		A.USER_ID,A.USER_NM,		    	\n"
					+	"		A.PASSWORD,A.USER_GRP_CD,			\n"
					+	"		A.LAST_SCH_CD,A.MAJOR_NM,			\n"
					+	"		A.FOREIGN_CAP_CD,A.ORG_NM,			\n"	
					+	"		A.DEPT_CD,A.POST_CD,A.EMAIL,		\n"
					+	"		A.TEL_NO,A.HP_NO,A.DEL_YN,			\n"
					+	"		A.REG_DTM,A.LAST_UPD_DTM,			\n"
					+	"		B.SHORT_NM AS DEPT_NM,				\n"
					+	"		C.SHORT_NM AS POST_NM,				\n"
					+   "		D.SHORT_NM AS USER_GRP_NM			\n"
					+	"	FROM TUSER A LEFT JOIN TGEN_CD B		\n"				
					+	"		ON A.DEPT_CD = B.GEN_CD				\n"				
					+	"			AND B.GEN_GRP_CD = 'DEPT'		\n"				
					+	"			AND B.DEL_YN = 'N'				\n"				
					+	"		LEFT JOIN TGEN_CD C					\n"				
					+	"		ON A.POST_CD = C.GEN_CD				\n"				
					+	"			AND C.GEN_GRP_CD = 'POST'		\n"				
					+	"			AND C.DEL_YN = 'N'				\n"	
					+	"		LEFT JOIN TGEN_CD D					\n"				
					+	"		ON A.POST_CD = D.GEN_CD				\n"				
					+	"			AND D.GEN_GRP_CD = 'USER_GRP'	\n"				
					+	"			AND D.DEL_YN = 'N'				\n"	
					+	"		AND A.DEL_YN='N'					\n"
					+	"	WHERE									\n";
		
		if(pEntity.m_sUserId != null){
			qry += " A.USER_ID = ?        \n";
		}
		
		if(pEntity.m_sPassWord!= null){
			qry += " AND A.PASSWORD = ?        \n";
		}
		
		try {
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(qry);
			
			if(pEntity.m_sUserId != null){
				pstmt.setString(index++, pEntity.m_sUserId);
			}
			
			if(pEntity.m_sPassWord!= null){
				pstmt.setString(index++, pEntity.m_sPassWord);
			}
			
			rset = pstmt.executeQuery();

		    int colSeq = 1;

			while (rset.next()) {

				rtnEntity.m_sUserId = rset.getString(colSeq++);
				rtnEntity.m_sUserNm = rset.getString(colSeq++);
				rtnEntity.m_sPassWord = rset.getString(colSeq++);
				rtnEntity.m_sUserGrpCd = rset.getString(colSeq++);
				rtnEntity.m_sLastSchCd = rset.getString(colSeq++);
				rtnEntity.m_sMajorNm = rset.getString(colSeq++);
				rtnEntity.m_sForeignCapCd = rset.getString(colSeq++);
				rtnEntity.m_sOrgNm = rset.getString(colSeq++);
				rtnEntity.m_sDeptCd = rset.getString(colSeq++);
				rtnEntity.m_sPostCd = rset.getString(colSeq++);
				rtnEntity.m_sEmail = rset.getString(colSeq++);        
				rtnEntity.m_sTelNo = rset.getString(colSeq++);
				rtnEntity.m_sHpNo = rset.getString(colSeq++);
				rtnEntity.m_sDelYn = rset.getString(colSeq++);
				rtnEntity.m_sRegDtm = rset.getString(colSeq++);
				rtnEntity.m_sLastUpdDtm = rset.getString(colSeq++);
				rtnEntity.m_sDeptNm = rset.getString(colSeq++);
				rtnEntity.m_sPostNm = rset.getString(colSeq++);
				rtnEntity.m_sUserGrpNm = rset.getString(colSeq++);
			}
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return rtnEntity;
	}

	/**
	 *    ȸ
	 * @param conn
	 * @param pEntity
	 * @return
	 * @throws SQLException
	 */
	public UserEntity[] list(UserEntity pEntity,int iPage,int iPagePerCnt) throws SQLException {
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		Vector vec = new Vector();
		UserEntity[] entities = null;
		UserEntity entity = null;
		
		int index = 1;
		
		/** TUSER ̺  ȸѴ. **/
		String qry = "	SELECT							\n"
				+	"		USER_ID,USER_NM,		    \n"
				+	"		PASSWORD,USER_GRP_CD,		\n"
				+	"		LAST_SCH_CD,MAJOR_NM,		\n"
				+	"		FOREIGN_CAP_CD,ORG_NM,		\n"	
				+	"		DEPT_CD,POST_CD,EMAIL,		\n"
				+	"		TEL_NO,HP_NO,DEL_YN,		\n"
				+	"		REG_DTM,LAST_UPD_DTM,		\n"
				+	"		DEPT_NM,POST_NM,USER_GRP_NM	\n"
				+	"	FROM										\n"
				+   "       (SELECT @ROWNUM:=0) R,                  \n"
				+	"		(SELECT									\n"
				+   "           @ROWNUM:=@ROWNUM+1 AS RNUM,         \n"
				+	"			TAB.*								\n"
				+	"		FROM(									\n"
				+   "			SELECT 									\n"
				+	"				A.USER_ID,A.USER_NM,		    	\n"
				+	"				A.PASSWORD,A.USER_GRP_CD,			\n"
				+	"				A.LAST_SCH_CD,A.MAJOR_NM,			\n"
				+	"				A.FOREIGN_CAP_CD,A.ORG_NM,			\n"	
				+	"				A.DEPT_CD,A.POST_CD,A.EMAIL,		\n"
				+	"				A.TEL_NO,A.HP_NO,A.DEL_YN,			\n"
				+	"				A.REG_DTM,A.LAST_UPD_DTM,			\n"
				+	"				B.SHORT_NM AS DEPT_NM,				\n"
				+	"				C.SHORT_NM AS POST_NM,				\n"
				+   "				D.SHORT_NM AS USER_GRP_NM			\n"
				+	"			FROM TUSER A LEFT JOIN TGEN_CD B		\n"				
				+	"				ON A.DEPT_CD = B.GEN_CD				\n"				
				+	"					AND B.GEN_GRP_CD = 'DEPT'		\n"				
				+	"					AND B.DEL_YN = 'N'				\n"				
				+	"				LEFT JOIN TGEN_CD C					\n"				
				+	"				ON A.POST_CD = C.GEN_CD				\n"				
				+	"					AND C.GEN_GRP_CD = 'POST'		\n"				
				+	"					AND C.DEL_YN = 'N'				\n"	
				+	"				LEFT JOIN TGEN_CD D					\n"				
				+	"				ON A.POST_CD = D.GEN_CD				\n"				
				+	"					AND D.GEN_GRP_CD = 'USER_GRP'	\n"				
				+	"					AND D.DEL_YN = 'N'				\n"	
				+	"			WHERE A.DEL_YN='N'						\n";
		
				if(!pEntity.m_sSearchText.equals("")){
					if(!pEntity.m_sGubun.equals("1")){
						//qry += " AND A.USER_NM LIKE '%'||?||'%'     \n";
						qry += " AND A.USER_NM LIKE '%" + pEntity.m_sSearchText + "%' \n";
					}else{
						//qry += " AND A.USER_ID LIKE '%'||?||'%'     \n";
						qry += " AND A.USER_ID LIKE '%" + pEntity.m_sSearchText + "%' \n";
					}
				}

					qry +=   "   ORDER BY A.USER_NM                 \n"
						+	"		)TAB							\n"
						+	"	) X WHERE X.RNUM BETWEEN ? AND ?	\n";
					
		try {
			
			conn = DBCPConn.getConnection("pool");

			CSLogger.debug(qry);
			
			pstmt = conn.prepareStatement(qry);
			
			//if(!pEntity.m_sSearchText.equals("")){
			//	pstmt.setString(index++, pEntity.m_sSearchText);				
			//}
			
			pstmt.setInt(index++, (iPage * iPagePerCnt)- (iPagePerCnt - 1));
            pstmt.setInt(index++, iPage * iPagePerCnt);
            
			rset = pstmt.executeQuery();
		    int colSeq = 1;
		    
			while (rset.next()) {
				colSeq = 1;
				entity = new UserEntity();
				entity.m_sUserId = rset.getString(colSeq++);
				entity.m_sUserNm = rset.getString(colSeq++);
				entity.m_sPassWord = rset.getString(colSeq++);
				entity.m_sUserGrpCd = rset.getString(colSeq++);
				entity.m_sLastSchCd = rset.getString(colSeq++);
				entity.m_sMajorNm = rset.getString(colSeq++);
				entity.m_sForeignCapCd = rset.getString(colSeq++);
				entity.m_sOrgNm = rset.getString(colSeq++);
				entity.m_sDeptCd = rset.getString(colSeq++);
				entity.m_sPostCd = rset.getString(colSeq++);
				entity.m_sEmail = rset.getString(colSeq++);        
				entity.m_sTelNo = rset.getString(colSeq++);
				entity.m_sHpNo = rset.getString(colSeq++);
				entity.m_sDelYn = rset.getString(colSeq++);
				entity.m_sRegDtm = rset.getString(colSeq++);
				entity.m_sLastUpdDtm = rset.getString(colSeq++);
				entity.m_sDeptNm = rset.getString(colSeq++);
				entity.m_sPostNm = rset.getString(colSeq++);
				entity.m_sUserGrpNm = rset.getString(colSeq++);
				
				vec.addElement(entity);
			}

		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		if (vec.size() > 0) {
			entities = new UserEntity[vec.size()];
			vec.copyInto(entities);
			vec.clear();
			vec = null;
		}
		
		return entities;
	}
	
	/**
	 *     ü Ǽ
	 * @param conn
	 * @param pEntity
	 * @return
	 * @throws SQLException
	 */
	public int listCount(UserEntity pEntity) throws SQLException {
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		int totCnt = 0;
		int index = 1;
		String sQry = "";
		String temp = "";
		
		/** TUSER ̺  ü ȸѴ. **/
		String qry = "	SELECT						\n"
				+	"		count(*) CNT			\n"				
				+	"	FROM TUSER					\n"
				+   "   WHERE DEL_YN = 'N'          \n";
		
		if(!pEntity.m_sSearchText.equals("")){
			if(pEntity.m_sGubun.equals("1")){
				//qry += " AND USER_NM = ?     \n";
				//qry += " AND USER_NM LIKE '%'||?||'%'     \n";
				qry += " AND USER_NM LIKE '%" + pEntity.m_sSearchText + "%'  \n";
				
			}else{
				//qry += " AND USER_ID = ?     \n";
				//qry += " AND USER_ID LIKE '%'||?||'%'     \n";
				qry += " AND USER_ID LIKE '%" + pEntity.m_sSearchText + "%'  \n";
			}
		}
		
					
		try {
			conn = DBCPConn.getConnection("pool");
			
			CSLogger.debug(qry);
			CSLogger.debug(pEntity.m_sSearchText);
			
			pstmt = conn.prepareStatement(qry);
			
			//if(!pEntity.m_sSearchText.equals("")){
			//	pstmt.setString(index++, pEntity.m_sSearchText);				
			//}
			
			rset = pstmt.executeQuery();

			if (rset.next()) {
				totCnt = rset.getInt(1);	
			}
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		return totCnt;
	}
	
	
	/**
     *======================================================
     * @޼ҵ : UserManager - insert
     * @return  : int  Ȯΰ
     * @param pEntity ڰ Entity
     * @    :   Ѵ.
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
	public int insert(UserEntity pEntity) throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		//ResultSet rset = null;
		
		int rtnCk = 0;
		int index = 1;

		/** TUSER ̺  Ѵ. **/
		String qry = "	INSERT INTO TUSER (				\n"
				+	"		USER_ID,USER_NM,		    \n"
				+	"		PASSWORD,USER_GRP_CD,		\n"
				+	"		LAST_SCH_CD,MAJOR_NM,		\n"
				+	"		FOREIGN_CAP_CD,ORG_NM,		\n"	
				+	"		DEPT_CD,POST_CD,EMAIL,		\n"
				+	"		TEL_NO,HP_NO,DEL_YN,		\n"
				+	"		REG_DTM,LAST_UPD_DTM		\n"
				+	"	)VALUES(					\n"
				+	"		?,?,					\n"
				+	"		?,?,					\n"
				+	"		?,?,					\n"
				+	"		?,?,					\n"
				+	"		?,?,?,					\n"
				+	"		?,?,'N',				\n"
				+	"		DATE_FORMAT(SYSDATE(),'%Y-%m-%d %H:%i:%s'),	\n"
				+	"		DATE_FORMAT(SYSDATE(),'%Y-%m-%d %H:%i:%s')	\n"	
				+	"	)							\n";

		try{					
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(qry);
			
			pstmt.setString(index++, pEntity.m_sUserId);
			pstmt.setString(index++, pEntity.m_sUserNm);
			pstmt.setString(index++, pEntity.m_sPassWord);
			pstmt.setString(index++, pEntity.m_sUserGrpCd);
			pstmt.setString(index++, pEntity.m_sLastSchCd);
			pstmt.setString(index++, pEntity.m_sMajorNm);
			pstmt.setString(index++, pEntity.m_sForeignCapCd);
			pstmt.setString(index++, pEntity.m_sOrgNm);
			pstmt.setString(index++, pEntity.m_sDeptCd);
			pstmt.setString(index++, pEntity.m_sPostCd);
			pstmt.setString(index++, pEntity.m_sEmail);
			pstmt.setString(index++, pEntity.m_sTelNo);
			pstmt.setString(index++, pEntity.m_sHpNo);
			//pstmt.setString(index++, pEntity.m_sDelYn);
			//pstmt.setString(index++, pEntity.m_sRegDtm);
			//pstmt.setString(index++, pEntity.m_sLastUpdDtm);

			rtnCk = pstmt.executeUpdate();
						
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				//rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		return rtnCk;
	}
	
	/**
     *======================================================
     * @޼ҵ : UserManager - insert
     * @return  : int  Ȯΰ
     * @param pEntity ڰ Entity
     * @    :   Ѵ.
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
	public int modify(UserEntity pEntity) throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		int rtnCk = 0;
		int index = 1;
		
		try{					

			/**HS_USER_INFO ̺  Ѵ. **/
			String qry = "	UPDATE TUSER						\n"
				+	"	SET USER_NM = ?,PASSWORD = ?,			\n"
				+	"		USER_GRP_CD = ?,LAST_SCH_CD = ?,	\n"
				+	"		MAJOR_NM = ?,FOREIGN_CAP_CD = ?,	\n"
				+	"		ORG_NM =?,DEPT_CD = ?,POST_CD = ?,	\n"
				+	"		EMAIL = ?,TEL_NO = ?,HP_NO = ?,		\n"
				+	"		LAST_UPD_DTM = DATE_FORMAT(SYSDATE(),'%Y-%m-%d %H:%i:%s')  			\n"
				+	"	WHERE USER_ID = ?						\n";

			conn = DBCPConn.getConnection("pool");

			pstmt = conn.prepareStatement(qry);
			System.out.println("==> qry : "+qry);
			
			pstmt.setString(index++, pEntity.m_sUserNm);
			pstmt.setString(index++, pEntity.m_sPassWord);
			pstmt.setString(index++, pEntity.m_sUserGrpCd);
			pstmt.setString(index++, pEntity.m_sLastSchCd);
			pstmt.setString(index++, pEntity.m_sMajorNm);
			pstmt.setString(index++, pEntity.m_sForeignCapCd);
			pstmt.setString(index++, pEntity.m_sOrgNm);
			pstmt.setString(index++, pEntity.m_sDeptCd);
			pstmt.setString(index++, pEntity.m_sPostCd);
			pstmt.setString(index++, pEntity.m_sEmail);
			pstmt.setString(index++, pEntity.m_sTelNo);
			pstmt.setString(index++, pEntity.m_sHpNo);
			//pstmt.setString(index++, pEntity.m_sLastUpdDtm);
			pstmt.setString(index++, pEntity.m_sUserId);
			
			rtnCk = pstmt.executeUpdate();
						
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				//rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		return rtnCk;
	}
	
	/**
     *======================================================
     * @޼ҵ : UserManager - insert
     * @return  : int  Ȯΰ
     * @param chkUserId   ̵
     * @    :   Ѵ.
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
	public int delete(UserEntity pEntity,String[] chkUserId) throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		
		int rtnCk = 0;
		int index = 1;
		String idTemp = "";
		
		for(int i = 0 ; i < chkUserId.length ; i++){
			idTemp += "'" + chkUserId[i] + "',";
		}
		if(!idTemp.equals("")){
			idTemp = idTemp.substring(0,idTemp.length()-1);			
		}
		
		String delSql = "	UPDATE 	TUSER					\n"
					  + "	SET DEL_YN = 'Y',				\n"
					  + "  		LAST_UPD_DTM = DATE_FORMAT(SYSDATE(),'%Y-%m-%d %H:%i:%s')	\n"
					  + "	WHERE USER_ID IN ("+idTemp+")	\n";
		try{					
			conn = DBCPConn.getConnection("pool");
			
			CSLogger.debug(delSql);
			CSLogger.debug(idTemp);
			
			pstmt = conn.prepareStatement(delSql);
			
			rtnCk = pstmt.executeUpdate();
						
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		return rtnCk;
	}

	/**
	 *======================================================
	 * @޼ҵ : UserDAO - getUserGrp
	 * @return  : UserEntity[]
	 * @return
	 * @    : ڱ׷  Ʈ 
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public UserEntity[] getUserGrp() throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		Vector vec = new Vector();
		UserEntity[] entities = null;
		UserEntity entity = null;
				
		String sSql = "  SELECT						\n"
					+ "		GEN_CD AS DEPT_CD,		\n"
					+ " 	SHORT_NM AS DEPT_NM		\n"
					+ "	 FROM TGEN_CD				\n"
					+ "	 WHERE DEL_YN = 'N'			\n"
					+ "	 	AND GEN_GRP_CD = 'USER_GRP'	\n"	
					+ "	 ORDER BY GEN_CD			\n";	
			
		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			rset = pstmt.executeQuery();
			
			while(rset.next()){
				entity = new UserEntity();
				
				entity.m_sUserGrpCd = rset.getString(1);
				entity.m_sUserGrpNm = rset.getString(2);
				
				vec.addElement(entity);
			}
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		if (vec.size() > 0) {
			entities = new UserEntity[vec.size()];
			vec.copyInto(entities);
			vec.clear();
			vec = null;
		}
		
		return entities;
		
	}
	
	/**
	 *======================================================
	 * @޼ҵ : UserDAO - getDept
	 * @return  : UserEntity[]
	 * @return
	 * @    : μ  Ʈ 
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public UserEntity[] getDept() throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		Vector vec = new Vector();
		UserEntity[] entities = null;
		UserEntity entity = null;
				
		String sSql = "  SELECT						\n"
					+ "		GEN_CD AS DEPT_CD,		\n"
					+ " 	SHORT_NM AS DEPT_NM		\n"
					+ "	 FROM TGEN_CD				\n"
					+ "	 WHERE DEL_YN = 'N'			\n"
					+ "	 	AND GEN_GRP_CD = 'DEPT'	\n"	
					+ "	 ORDER BY GEN_CD			\n";	
			
		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			rset = pstmt.executeQuery();
			
			while(rset.next()){
				entity = new UserEntity();
				
				entity.m_sDeptCd = rset.getString(1);
				entity.m_sDeptNm = rset.getString(2);
				
				vec.addElement(entity);
			}
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		if (vec.size() > 0) {
			entities = new UserEntity[vec.size()];
			vec.copyInto(entities);
			vec.clear();
			vec = null;
		}
		
		return entities;
		
	}
	
	/**
	 *======================================================
	 * @޼ҵ : UserDAO - getPost
	 * @return  : UserEntity[]
	 * @return
	 * @    :  Ʈ
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public UserEntity[] getPost() throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		Vector vec = new Vector();
		UserEntity[] entities = null;
		UserEntity entity = null;
				
		String sSql = "  SELECT						\n"
			+ "		GEN_CD AS DEPT_CD,		\n"
			+ " 	SHORT_NM AS DEPT_NM		\n"
			+ "	 FROM TGEN_CD				\n"
			+ "	 WHERE DEL_YN = 'N'			\n"
			+ "	 	AND GEN_GRP_CD = 'POST'	\n"	
			+ "	 ORDER BY GEN_CD			\n";	
		
		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			rset = pstmt.executeQuery();
			
			while(rset.next()){
				entity = new UserEntity();
				
				entity.m_sPostCd = rset.getString(1);
				entity.m_sPostNm = rset.getString(2);
				
				vec.addElement(entity);
			}
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		if (vec.size() > 0) {
			entities = new UserEntity[vec.size()];
			vec.copyInto(entities);
			vec.clear();
			vec = null;
		}
		
		return entities;
		
	}

	/**
	 *======================================================
	 * @޼ҵ : UserDAO - getLastSch
	 * @return  : UserEntity[]
	 * @return
	 * @    : з  Ʈ
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public UserEntity[] getLastSch() throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		Vector vec = new Vector();
		UserEntity[] entities = null;
		UserEntity entity = null;
				
		String sSql = "  SELECT						\n"
			+ "		GEN_CD AS DEPT_CD,		\n"
			+ " 	SHORT_NM AS DEPT_NM		\n"
			+ "	 FROM TGEN_CD				\n"
			+ "	 WHERE DEL_YN = 'N'			\n"
			+ "	 	AND GEN_GRP_CD = 'LAST_SCH'	\n"	
			+ "	 ORDER BY GEN_CD			\n";	
		
		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			rset = pstmt.executeQuery();
			
			while(rset.next()){
				entity = new UserEntity();
				
				entity.m_sLastSchCd = rset.getString(1);
				entity.m_sPostNm = rset.getString(2);
				
				vec.addElement(entity);
			}
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		if (vec.size() > 0) {
			entities = new UserEntity[vec.size()];
			vec.copyInto(entities);
			vec.clear();
			vec = null;
		}
		
		return entities;
		
	}
	
	/**
	 *======================================================
	 * @޼ҵ : UserDAO - getForeignCap
	 * @return  : UserEntity[]
	 * @return
	 * @    : ܱɷ  Ʈ
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public UserEntity[] getForeignCap() throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		Vector vec = new Vector();
		UserEntity[] entities = null;
		UserEntity entity = null;
				
		String sSql = "  SELECT						\n"
			+ "		GEN_CD AS DEPT_CD,		\n"
			+ " 	SHORT_NM AS DEPT_NM		\n"
			+ "	 FROM TGEN_CD				\n"
			+ "	 WHERE DEL_YN = 'N'			\n"
			+ "	 	AND GEN_GRP_CD = 'FOREIGN_CAP'	\n"	
			+ "	 ORDER BY GEN_CD			\n";	
		
		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			rset = pstmt.executeQuery();
			
			while(rset.next()){
				entity = new UserEntity();
				
				entity.m_sForeignCapCd = rset.getString(1);
				entity.m_sPostNm = rset.getString(2);
				
				vec.addElement(entity);
			}
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		if (vec.size() > 0) {
			entities = new UserEntity[vec.size()];
			vec.copyInto(entities);
			vec.clear();
			vec = null;
		}
		
		return entities;
		
	}
	
	/**
	 *======================================================
	 * @޼ҵ : UserInfoDAO - getUserIdChk
	 * @return  : int
	 * @param userId
	 * @return
	 * @    :  ̵ ߺüũ
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public int getUserIdChk(String userId) throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		int rtnCk = 0;
		int index = 1;
		
		String sSql =  "	SELECT						\n" 
					+  "		count(*) as CNT			\n"
					+  "	FROM TUSER					\n"
					+  "	WHERE USER_ID = ?			\n";
					
		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			pstmt.setString(index++, userId);
			
			rset = pstmt.executeQuery();
			
			if(rset.next()){
				rtnCk = rset.getInt("CNT"); 
			}
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		return rtnCk;
	}
	
	/**
	 *======================================================
	 * @޼ҵ : UserDAO - passwdChange
	 * @return  : int
	 * @param pEntity
	 * @return
	 * @    :  йȣ 
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public int passwdChange(UserEntity pEntity) throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		
		int index = 1;
		int rtnCk = 0;
		
		String sSql = "	UPDATE TUSER				\n"
					+ "	SET PASSWORD = ?			\n"
					+ "	WHERE USER_ID = ?			\n"
					+ "	AND DEL_YN = 'N'			\n";
		
		try{
			
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			
			pstmt.setString(index++, pEntity.m_sPassWord);
			pstmt.setString(index++, pEntity.m_sUserId);
			
			rtnCk = pstmt.executeUpdate();
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		return rtnCk;
	}
}
